%define modname   fuse
%define modver    2.7.4
%define kernver   2.6.9-89.35.1.EL
%define kernstr   %(echo %{kernver} | tr '-' '_')

%define modtop    addon
%define moddir    %{modtop}/fs

%define huge      1
%define smp       1
%define xenU      1


Summary:          Filesystem in Userspace (FUSE)
Name:             fuse-kmod
Version:          %{modver}
Release:          1.%{kernstr}%{?dist}%{?pext}
Epoch:            1
License:          GPL
Group:            System Environment/Kernel
Source0:          http://dl.sourceforge.net/sourceforge/%{modname}/%{modname}-%{modver}.tar.gz
URL:              http://%{modname}.sourceforge.net/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           Miklos Szeredi <miklos@szeredi.hu>
ExclusiveArch:    i586 i686 x86_64

%description
FUSE (Filesystem in Userspace) is a simple interface for userspace
programs to export a virtual filesystem to the Linux kernel. FUSE
also aims to provide a secure method for non privileged users to
create and mount their own filesystem implementations.


%package       -n kmod-%{modname}
Summary:          FUSE kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-%{_target_cpu} = %{kernver}
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
BuildRequires:    kernel-devel-%{_target_cpu} = %{kernver}

%description   -n kmod-%{modname}
This package provides the FUSE kernel modules built for the Linux kernel
%{kernver} for the %{_target_cpu} family of processors.


%package       -n kmod-%{modname}-hugemem
Summary:          FUSE kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}hugemem
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-hugemem-%{_target_cpu} = %{kernver}
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
%if %{huge}
%ifarch i686
BuildRequires:    kernel-hugemem-devel-%{_target_cpu} = %{kernver}
%endif
%endif

%description   -n kmod-%{modname}-hugemem
This package provides the FUSE kernel modules built for the Linux kernel
%{kernver}hugemem for the %{_target_cpu} family of processors.


%package       -n kmod-%{modname}-largesmp
Summary:          FUSE kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}largesmp
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-largesmp-%{_target_cpu} = %{kernver}
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
%if %{smp}
%ifarch x86_64
BuildRequires:    kernel-largesmp-devel-%{_target_cpu} = %{kernver}
%endif
%endif

%description   -n kmod-%{modname}-largesmp
This package provides the FUSE kernel modules built for the Linux kernel
%{kernver}largesmp for the %{_target_cpu} family of processors.


%package       -n kmod-%{modname}-smp
Summary:          FUSE kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}smp
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-smp-%{_target_cpu} = %{kernver}
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
%if %{smp}
BuildRequires:    kernel-smp-devel-%{_target_cpu} = %{kernver}
%endif

%description   -n kmod-%{modname}-smp
This package provides the FUSE kernel modules built for the Linux kernel
%{kernver}smp for the %{_target_cpu} family of processors.


%package       -n kmod-%{modname}-xenU
Summary:          FUSE kernel module(s)
Group:            System Environment/Kernel
Provides:         kernel-modules = %{kernver}xenU
Provides:         %{modname}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:         kernel-xenU-%{_target_cpu} = %{kernver}
Requires:         %{modname}-kmod-common >= %{modver}
Requires(post):   /sbin/depmod
Requires(postun): /sbin/depmod
%if %{xenU}
%ifarch i686 x86_64
BuildRequires:    kernel-xenU-devel-%{_target_cpu} = %{kernver}
%endif
%endif

%description   -n kmod-%{modname}-xenU
This package provides the FUSE kernel modules built for the Linux kernel
%{kernver}xenU for the %{_target_cpu} family of processors.


%prep
%setup -q -n %{modname}-%{modver}


%build
BuildModule() {
  # Prepare environment
  if [ -n "$2" ]; then
    echo "BUILDING MODULE FOR $2 $1 KERNEL..."
    config="$2-$1"
  else
    echo "BUILDING MODULE FOR up $1 KERNEL..."
    config="$1"
  fi

  # Build module
  pushd kernel
  %{__make} clean || :

  %configure \
	--with-kernel=%{_usrsrc}/kernels/%{kernver}-${config}

  %{__make} \
	all
  popd

  %{__mv} kernel/%{modname}.ko %{modname}-${config}.mod
}

%if %{huge}
%ifarch i686
BuildModule %{_target_cpu} hugemem
%endif
%endif

%if %{smp}
%ifarch i586 i686 x86_64
BuildModule %{_target_cpu} smp
%endif
%ifarch x86_64
BuildModule %{_target_cpu} largesmp
%endif
%endif

%if %{xenU}
%ifarch i686 x86_64
BuildModule %{_target_cpu} xenU
%endif
%endif

%ifarch i586 i686 x86_64
BuildModule %{_target_cpu}
%endif


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_prefix}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}hugemem/%{moddir}/%{modname}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}largesmp/%{moddir}/%{modname}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}smp/%{moddir}/%{modname}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}xenU/%{moddir}/%{modname}
%{__mkdir_p} ${RPM_BUILD_ROOT}/lib/modules/%{kernver}/%{moddir}/%{modname}

%if %{huge}
%ifarch i686
%{__install} -m 0744 %{modname}-hugemem-%{_target_cpu}.mod \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}hugemem/%{moddir}/%{modname}/%{modname}.ko
%endif
%endif

%if %{smp}
%ifarch i586 i686 x86_64
%{__install} -m 0744 %{modname}-smp-%{_target_cpu}.mod \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}smp/%{moddir}/%{modname}/%{modname}.ko
%endif
%ifarch x86_64
%{__install} -m 0744 %{modname}-largesmp-%{_target_cpu}.mod \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}largesmp/%{moddir}/%{modname}/%{modname}.ko
%endif
%endif

%if %{xenU}
%ifarch i686 x86_64
%{__install} -m 0744 %{modname}-xenU-%{_target_cpu}.mod \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}xenU/%{moddir}/%{modname}/%{modname}.ko
%endif
%endif

%ifarch i586 i686 x86_64
%{__install} -m 0744 %{modname}-%{_target_cpu}.mod \
	${RPM_BUILD_ROOT}/lib/modules/%{kernver}/%{moddir}/%{modname}/%{modname}.ko
%endif


%post -n kmod-%{modname}
/sbin/depmod -aeF /boot/System.map-%{kernver} %{kernver} >/dev/null || :

%post -n kmod-%{modname}-hugemem
/sbin/depmod -aeF /boot/System.map-%{kernver}hugemem %{kernver}hugemem >/dev/null || :

%post -n kmod-%{modname}-largesmp
/sbin/depmod -aeF /boot/System.map-%{kernver}largesmp %{kernver}largesmp >/dev/null || :

%post -n kmod-%{modname}-smp
/sbin/depmod -aeF /boot/System.map-%{kernver}smp %{kernver}smp >/dev/null || :

%post -n kmod-%{modname}-xenU
/sbin/depmod -aeF /boot/System.map-%{kernver}xenU %{kernver}xenU >/dev/null || :


%postun -n kmod-%{modname}
/sbin/depmod -aF /boot/System.map-%{kernver} %{kernver} &>/dev/null || :

%postun -n kmod-%{modname}-hugemem
/sbin/depmod -aF /boot/System.map-%{kernver}hugemem %{kernver}hugemem &>/dev/null || :

%postun -n kmod-%{modname}-largesmp
/sbin/depmod -aF /boot/System.map-%{kernver}largesmp %{kernver}largesmp &>/dev/null || :

%postun -n kmod-%{modname}-smp
/sbin/depmod -aF /boot/System.map-%{kernver}smp %{kernver}smp &>/dev/null || :

%postun -n kmod-%{modname}-xenU
/sbin/depmod -aF /boot/System.map-%{kernver}xenU %{kernver}xenU &>/dev/null || :


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%ifarch i586 i686 x86_64
%files -n kmod-%{modname}
%defattr(744,root,root)
/lib/modules/%{kernver}/%{modtop}
%endif

%if %{huge}
%ifarch i686
%files -n kmod-%{modname}-hugemem
%defattr(744,root,root)
/lib/modules/%{kernver}hugemem/%{modtop}
%endif
%endif

%if %{smp}
%ifarch i586 i686 x86_64
%files -n kmod-%{modname}-smp
%defattr(744,root,root)
/lib/modules/%{kernver}smp/%{modtop}
%endif
%ifarch x86_64
%files -n kmod-%{modname}-largesmp
%defattr(744,root,root)
/lib/modules/%{kernver}largesmp/%{modtop}
%endif
%endif

%if %{xenU}
%ifarch i686 x86_64
%files -n kmod-%{modname}-xenU
%defattr(744,root,root)
/lib/modules/%{kernver}xenU/%{modtop}
%endif
%endif


%changelog
* Thu Jan 20 2011 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.35.1.EL
- New kernel version (2.6.9-89.35.1.EL)

* Sat Dec 04 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.33.1.EL
- New kernel version (2.6.9-89.33.1.EL)

* Thu Oct 21 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.31.1.EL
- New kernel version (2.6.9-89.31.1.EL)

* Thu Oct 07 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.29.1.EL
- New kernel version (2.6.9-89.29.1.EL)

* Thu Sep 09 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.29.EL
- New kernel version (2.6.9-89.0.29.EL)

* Thu Aug 26 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.28.EL
- New kernel version (2.6.9-89.0.28.EL)

* Wed Aug 25 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.26.EL
- New kernel version (2.6.9-89.0.26.EL)

* Fri May 07 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.25.EL
- New kernel version (2.6.9-89.0.25.EL)

* Thu Mar 18 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.23.EL
- New kernel version (2.6.9-89.0.23.EL)

* Fri Feb 05 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.20.EL
- New kernel version (2.6.9-89.0.20.EL)

* Fri Jan 22 2010 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.19.EL
- New kernel version (2.6.9-89.0.19.EL)

* Fri Dec 18 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.18.EL
- New kernel version (2.6.9-89.0.18.EL)

* Mon Nov 09 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.16.EL
- New kernel version (2.6.9-89.0.16.EL)

* Tue Oct 27 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.15.EL
- New kernel version (2.6.9-89.0.15.EL)

* Wed Sep 16 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.11.EL
- New kernel version (2.6.9-89.0.11.EL)

* Tue Aug 25 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.9.EL
- New kernel version (2.6.9-89.0.9.EL)

* Mon Aug 24 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.7.EL
- New kernel version (2.6.9-89.0.7.EL)

* Mon Aug 24 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.0.3.EL
- New kernel version (2.6.9-89.0.3.EL)

* Mon Aug 24 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_89.EL
- New kernel version (2.6.9-89.EL)

* Tue May 05 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_78.0.22.EL
- New kernel version (2.6.9-78.0.22.EL)

* Tue Apr 21 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_78.0.17.EL
- New kernel version (2.6.9-78.0.17.EL)

* Fri Jan 16 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_78.0.13.EL
- New kernel version (2.6.9-78.0.13.EL)

* Fri Nov 21 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_78.0.8.EL
- New kernel version (2.6.9-78.0.8.EL)

* Mon Oct 13 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_78.0.5.EL
- New kernel version (2.6.9-78.0.5.EL)

* Fri Oct 10 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_78.0.1.EL
- New kernel version (2.6.9-78.0.1.EL)

* Fri Oct 10 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.4-1.2.6.9_78.EL
- New module version (2.7.4)
- New kernel version (2.6.9-78.EL)

* Fri Jul 25 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.3-1.2.6.9_67.0.22.EL
- New kernel version (2.6.9-67.0.22.EL)

* Tue Jul 22 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.3-1.2.6.9_67.0.20.EL
- New kernel version (2.6.9-67.0.20.EL)

* Sat Jun 28 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.3-1.2.6.9_67.0.15.EL
- New kernel version (2.6.9-67.0.15.EL)

* Sat Jun 28 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.3-1.2.6.9_67.0.7.EL
- New kernel version (2.6.9-67.0.7.EL)

* Sat Jun 28 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1:2.7.3-1.2.6.9_67.0.4.EL
- New module version (2.7.3)
- New kernel version (2.6.9-67.0.4.EL)
- Fixed versioning
- Rewritten for buildsystem

* Sat Jan 19 2008 peter.pramberger@member.fsf.org 2.7.2_2.6.9.67.0.1.EL-3
- new kernel (2.6.9-67.0.1.EL)

* Sat Jan 19 2008 peter.pramberger@member.fsf.org 2.7.2_2.6.9.67.EL-3
- new kernel (2.6.9-67.EL)

* Sat Jan 19 2008 peter.pramberger@member.fsf.org 2.7.2_2.6.9.55.0.12.EL-3
- created
